Attribute VB_Name = "Module1"
Option Explicit
Public PrvCoverLayer As MapObjects2.MapLayer

Public Function LoadSDELayers(layer As String, lyrName As String, symColor As MapObjects2.ColorConstants, symStyle As Integer, symType As Integer, symSize As Integer, _
symOlnColor As MapObjects2.ColorConstants, vis As Boolean) As MapObjects2.MapLayer
     'If Not moConn.Connected Then
     '     Exit Function
     'Else
          Dim gSet As MapObjects2.GeoDataset
          
          Set gSet = moConn.FindGeoDataset(layer)
          If gSet Is Nothing Then
               MsgBox "Error opening SDE layer "
               Exit Function
          Else
                Dim newLayer As New MapObjects2.MapLayer
                newLayer.GeoDataset = gSet
                newLayer.Name = lyrName
                newLayer.Symbol.SymbolType = symType
                newLayer.Symbol.Color = symColor
                newLayer.Symbol.Style = symStyle
                newLayer.Symbol.Size = symSize
                If newLayer.shapeType = moShapeTypePolygon Then
                    newLayer.Symbol.OutlineColor = symOlnColor
                End If
               newLayer.Visible = vis
               'newLayer.Tag = "[SDE]" & newLayer.Name & "," & momap.Server & "," & momap.Database _
                              & "," & momap.User & "," & momap.Password
               SPrvMSMain.moMap.Layers.Add newLayer
          End If
     'End If
     Set LoadSDELayers = newLayer
End Function


Public Sub Connect2SDE(bFlag As Boolean)
On Error GoTo Connect2SDE_Err

    If Not moConn.Connected Then
        If moConn.Connect Then
            Set PrvCoverLayer = LoadSDELayers("DBO.PrvCover.BUS_FID.POLYGONS", "PrvCover", moLightGray, 2, 2, 1, moMagenta, False)
        End If
    End If
    
    ' ..........
    
    Exit Sub

Connect2SDE_Err:
    ShowError "Connect2SDE_Err: " & Err.Description
End Sub

Private Sub ShowPolygon(ByVal oShape As MapObjects2.Polygon, objMap As MapPoint.Map)
On Error GoTo ShowPolygon_Err

    Dim oPoints As MapObjects2.POINTS
    Dim oShapePoint As MapObjects2.Point
    Dim objLoc() As MapPoint.Location
    Dim i As Integer
    
    Set oPoints = oShape.Parts(0)
    ReDim objLoc(oPoints.Count)
    i = 0
    For Each oShapePoint In oPoints
        Set objLoc(i) = objMap.GetLocation(oShapePoint.y, oShapePoint.X)
        i = i + 1
    Next oShapePoint
    Set objLoc(i) = objLoc(0)

    objMap.Union(objLoc).GoTo

    objMap.Shapes.AddPolyline(objLoc).Name = "Vendor"
    
    objMap.Shapes.Item("Vendor").Line.Weight = 2
    
    'objMap.Shapes.Item("Vendor").Line.ForeColor = vbGreen
    
    Exit Sub
ShowPolygon_Err:
    MsgBox "ShowPolygon_Err:" & Err.Description
End Sub


Private Sub GetPRVPOLY(lPrvID As Long, objMap As MapPoint.Map)
On Error GoTo GetPRVPOLY_CErr:

    Dim bHavePoly As Boolean
    Dim rs As MapObjects2.Recordset
    Dim p As New MapObjects2.Polygon
    Dim objLoc As MapPoint.Location
    
    Call ClearMap(objMap)
            
    Set rs = PrvCoverLayer.SearchExpression("PrvID=" & Str(lPrvID))
    
    ' Check if there is polygon for this vendor
    If rs.EOF Then
        bHavePoly = False
    ElseIf IsNull(rs("Shape").Value) Then
        bHavePoly = False
    Else
        bHavePoly = True
    End If
    
    If bHavePoly Then
        Set p = rs("Shape").Value
        ShowPolygon p, objMap
    ElseIf sVCity <> "" And sVState <> "" And sVState <> "PR" And sVState <> "VI" Then
           'Get a location, then zoom to the best map view of this location
        Set objLoc = objMap.FindResults(sVCity & ", " & sVState).Item(1)
        objLoc.GoTo
    ElseIf dblLat <> 0# And dblLon <> 0# Then
        Set objLoc = objMap.GetLocation(dblLat, dblLon)
        objLoc.GoTo
    End If
    
    Exit Sub

GetPRVPOLY_CErr:
  MsgBox "GetPRVPOLY_CErr: " & Err.Description
End Sub

Private Sub GetPRVPOLY(lPrvID As Long, objMap As MapPoint.Map)
On Error GoTo GetPRVPOLY_CErr:

    Dim rs As MapObjects2.Recordset
    Dim p As New MapObjects2.Polygon
    Dim bHavePoly As Boolean
              
    Set rs = PrvCoverLayer.SearchExpression("PrvID=" & Str(lPrvID))
    
    ' Check if there is polygon for this vendor
    If rs.EOF Then
        bHavePoly = False
    ElseIf IsNull(rs("Shape").Value) Then
        bHavePoly = False
    Else
        bHavePoly = True
    End If
    
    If bHavePoly Then
        Set p = rs("Shape").Value
        ShowPolygon p, objMap
    End If
    
    Exit Sub

GetPRVPOLY_CErr:
  MsgBox "GetPRVPOLY_CErr: " & Err.Description
End Sub


